# Module

The system currently supports a powerful customizable module to utilize any widget in MyShell workshop.&#x20;

Other types of modules are essentially `AnyWidgetModule` without `widget_id`.

`SupportModule`

| Field's Name   | JSON Type (Required/Optional)                                                                                | Description                                                                                                                  | Example                           |
| -------------- | ------------------------------------------------------------------------------------------------------------ | ---------------------------------------------------------------------------------------------------------------------------- | --------------------------------- |
| module\_type   | "AnyWidgetModule" \| “LLMModule” \| “LLMFunctionModule” \| “TtsModule” \| “GoogleSearchModule”｜ (Required)   | The module type defines the module config.                                                                                   |                                   |
| module\_config | “AnyWidgetConfig" \| “LLMConfig” \| “LLMFunctionConfig” \| “TTSConfig” \| “GoogleSearchConfig” \| (Required) | The configuration takes inputs and produces a result. All module\_config have a output\_name field for the execution result. |                                   |
| name           | string (Optional)                                                                                            | The name of the module is primarily for identification and comprehension.                                                    | ‘generate\_img\_for\_user\_reply’ |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.myshell.ai/create/pro-config-mode/api-reference/module.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
